#include <Stepper.h>
#include <Servo.h>
// Setting hardware
const int Led1 = 0;
const int Led2 = 1;
const int Led3 = 2;
const int mPin1 = 3;    
const int mPin2 = 4;
const int mPin3 = 5;
const int mPin4 = 6;
const int Led4 = 7;
const int Led5 = 8;
const int DoorServo = 9;//pwm
const int Speaker = 10; //pwm
const int Right = 11;   //Right button input
const int Left = 12;    //Left Button input
const int Flip = 13;    //Switch to detect flip display at first card
const int maxcard =31;
// Setting Variables
int FlipSpeed = 60;     //Rotation speed of flip display
int CurrentCard = 1;
int bFlip = 0;
int bLeft = 0;
int bRight = 0;
int bsFlip = 0;
int bsLeft = 0;
int bsRight = 0;
int Movement;
int resetcount = 0;
int cardoffset[41];
int d2=1;
int leftover =0;
int x =0;
// Game setting Variables
int score = 0;
boolean cards[32];
boolean cardanswer[32];
int state = 0;
int newstate = 0;
boolean statechange = false;
int randomcard = 0;
boolean options = false;
boolean notfound = true;
boolean answer = false;

Stepper FlipFlap(200,mPin1,mPin2,mPin3,mPin4);
Servo DServo;

boolean debug = false;
boolean debug2 = false;

void setup() {
 if (debug) {
   Serial.begin(57600);
   Serial.println("Debug started");
  }
 else
  {
    pinMode(Led1,OUTPUT);
    pinMode(Led2,OUTPUT);
  }    
 
 pinMode(Flip,INPUT);
 pinMode(Left,INPUT);
 pinMode(Right,INPUT);
 pinMode(Speaker,OUTPUT);
 pinMode(Led3,OUTPUT);
 pinMode(Led4,OUTPUT);
 pinMode(Led5,OUTPUT);
 
 DServo.attach(DoorServo);
 DoorClose();
 
 FlipFlap.setSpeed(FlipSpeed);
 bsFlip = digitalRead(Flip);   
 while (bsFlip ==1) {
   FlipFlap.step(1);
   bsFlip = digitalRead(Flip);   
 }
  while (bsFlip ==0) {
   FlipFlap.step(1);
   bsFlip = digitalRead(Flip);   
  }
 
  beep(500);
  int CurrentCard = 1;

  for( int i=1; i<=30; i++) { cards[i] = false;}

  cardanswer[1]=true;
  cardanswer[2]=true;
  cardanswer[3]=true;
  cardanswer[4]=false;
  cardanswer[5]=false;
  cardanswer[6]=true;
  cardanswer[7]=false;
  cardanswer[8]=false;
  cardanswer[9]=false;
  cardanswer[10]=false;
  cardanswer[11]=true;
  cardanswer[12]=true;
  cardanswer[13]=false;
  cardanswer[14]=true;
  cardanswer[15]=true;
  cardanswer[16]=false;
  cardanswer[17]=false;
  cardanswer[18]=true;
  cardanswer[19]=true;
  cardanswer[20]=false;
  cardanswer[21]=false;
  cardanswer[22]=true;
  cardanswer[23]=false;
  cardanswer[24]=false;
  cardanswer[25]=false;
  cardanswer[26]=true;
  cardanswer[27]=false;
  cardanswer[28]=true;
  cardanswer[29]=false;
  cardanswer[30]=true;
  cardanswer[31]=false;
  

  cardoffset[1] = 10;
  cardoffset[2] = 8;
  cardoffset[3] = 10;
  cardoffset[4] = 10;
  cardoffset[5] = 10;
  cardoffset[6] = 13;
  cardoffset[7] = 12;
  cardoffset[8] = 14;
  cardoffset[9] = 18;
  cardoffset[10] = 18;
  cardoffset[11] = 22;
  cardoffset[12] = 22;
  cardoffset[13] = 25;
  cardoffset[14] = 25;
  cardoffset[15] = 30;
  cardoffset[16] = 30;
  cardoffset[17] = 35;
  cardoffset[18] = 40;
  cardoffset[19] = 40;
  cardoffset[20] = 40;
  cardoffset[21] = 40;
  cardoffset[22] = 50;
  cardoffset[23] = 50;
  cardoffset[24] = 50;
  cardoffset[25] = 50;
  cardoffset[26] = 55;
  cardoffset[27] = 60;
  cardoffset[28] = 60;
  cardoffset[29] = 60;
  cardoffset[30] = 70;
  cardoffset[31] = 70;
  cardoffset[32] = 70;
  cardoffset[33] = 70;
  cardoffset[34] = 10;
  cardoffset[35] = 10;
  cardoffset[36] = 10;
  cardoffset[37] = 10;
  cardoffset[38] = 5;
  cardoffset[39] = 5;
  cardoffset[40] = 10;
  
  
  
}

void loop() {
  bsFlip = digitalRead(Flip);
  bsLeft = digitalRead(Left);
  bsRight = digitalRead(Right);
  x = random(1,maxcard+1);
  // Check for both bottons pressed
  // 4 seconds hold is door close
  // 8 seconds hold is door open
  if (bsLeft == HIGH && bsRight ==HIGH)  {
    if (debug) { Serial.println("Both bottons pressed"); }
    beep(100);
    resetcount = 0;
     while (bsLeft ==HIGH && bsRight == HIGH) {
     resetcount++;       
     if (resetcount == 400) { beep(50); }
     if (resetcount == 800) { beep(50); }
     bsLeft = digitalRead(Left);
     bsRight = digitalRead(Right);
     delay(8);
     }
    if (debug) { Serial.println(resetcount); }

     if (resetcount > 800) { 
       DoorOpen(); 
       }
       else
        {
         if (resetcount > 400) { 
           DoorClose(); 
          }
        }
  }

  if (bsLeft != bLeft) {
     if (bsLeft == HIGH) {
        if (debug) { Serial.print(state); Serial.println(" - Left pressed"); }
         bLeft = bsLeft;  
         if (debug2) {
          d2 = CurrentCard +1;
          if (d2>40) d2=1;
          if (debug) { Serial.print("DEBUG2: +1 -> "); Serial.println(d2);}
          FlipCard(d2);  
           while ((bsLeft != HIGH && bsRight !=HIGH)) {  // make sure buttons are unpressed before continue
       bsLeft = digitalRead(Left);
       bsRight = digitalRead(Right);
     }
         }
         else
         {
         switch(state) {
         case 0: 
             statechange = true; newstate =1;
             break;
         case 1: 
             statechange = true; newstate =2;
             break;
         case 2: 
             answer = false;
             statechange = true; newstate =2;
             break;
         case 3: 
             answer = false;
             statechange = true; newstate =3;
             break;
          }
         }
       }
       else
       {
        
         bLeft = bsLeft;
       }
       
     }
  
  if (bsRight != bRight) {
    Serial.println(bsRight);
    if (bsRight == 1 ) 
     { 
        if (debug) { Serial.println("Right pressed"); }
        bRight = bsRight; 
        if (debug2) {
          d2 = CurrentCard +10;
          if (d2>40) d2 = 40-d2;
          if (debug) { Serial.print("DEBUG2: +10 -> "); Serial.println(d2);}
          FlipCard(d2);  
           while ((bsLeft != HIGH && bsRight !=HIGH)) {  // make sure buttons are unpressed before continue
       bsLeft = digitalRead(Left);
       bsRight = digitalRead(Right);
     }
         }
         else
         {
        switch(state) {
         case 0: 
             statechange = true; newstate =1;
             break;
         case 1: 
             statechange = true; newstate =2;
             break;
         case 2: 
             answer = true;
             statechange = true; newstate =2;
             break;
         case 3: 
             answer = true;
             statechange = true; newstate =3;
             break;
        }
         }
     }
    else
    {
      
      bRight = bsRight;
    }
   }
  
  // Execute actions
  // state 0 - Start stage with welcome screen - CARD 1
  // state 1 - Explain game                    - CARD 40
  // state 2 - Game in progress                - Randon
  
  if (statechange) {
    statechange = false;
       // if (debug) { Serial.print("State change : "); Serial.print(state); Serial.print (" - > "); Serial.println(newstate); }
    state = newstate;
    switch(state) {
    case 1: 
      FlipCard(2);
      break;
    case 2: 
       options=false;
       for (int i=1; i<=maxcard; i++) {
         if (cards[i] == false) {options = true;}
       }
       if (options == false) {
         for(int i=1; i<=maxcard; i++) { cards[i] = false;}
        if (debug) { Serial.println("all cards asked, resetting"); }
      }
      notfound = true;
       while (notfound) {
         randomcard = random(1,maxcard+1);
         if (cards[randomcard] == false) {
           notfound=false;
           cards[randomcard]=true;
       }
       }
       Serial.print ("Random selected card : ");
       Serial.println(randomcard);
       FlipCard(randomcard+2);
       state =3;
       break;
    case 3: 
       // check answer
       
        // correct answer
        if (answer == cardanswer[randomcard]) {
          if (debug) {Serial.print ("Correct answer! "); Serial.println(randomcard);}
          score = score +1;
         if (score == 5) { //winner winner, chicken dinner, lets open the door
            if (debug) {Serial.print ("Winner, lets open the door "); }
            FlipCard(40);
            updatescore(score);  
            DoorOpen();
            while (1 == 1) {
             updatescore(0);
             delay(500);
             updatescore(5);
             delay(500);
              
            }
            
         }
         else
         {
           FlipCard(39);
          updatescore(score);       
         }
         }
        else // INCORRECT ANSWER
        {
         if (debug) {Serial.print ("Incorrect answer! anserwer given: "); Serial.print(answer); Serial.print("Card: "); Serial.print(randomcard);}
         FlipCard(38); 
         score=0;
         updatescore(score);
        }
        
       state =2;
        break;
    
    }
    
    
        
    
     while ((bsLeft != HIGH && bsRight !=HIGH)) {  // make sure buttons are unpressed before continue
       bsLeft = digitalRead(Left);
       bsRight = digitalRead(Right);
     }
     //if (debug) { Serial.println("Button released"); }
    
  } // end statechanges
  

} // end loop

void DoorOpen() {
 DServo.write(120);
}

void DoorClose() {
  DServo.write(40);
}

void updatescore(int s) {
  if (debug) {Serial.print ("Score :"); Serial.println(s);}
  switch(s) {
   case 0:
    if (debug == false) digitalWrite(Led1,LOW);
    if (debug == false) digitalWrite(Led2,LOW);
    digitalWrite(Led3,LOW);
    digitalWrite(Led4,LOW);
    digitalWrite(Led5,LOW);
   break;
   case 1:
    if (debug == false) digitalWrite(Led1,HIGH);
    if (debug == false) digitalWrite(Led2,LOW);
    digitalWrite(Led3,LOW);
    digitalWrite(Led4,LOW);
    digitalWrite(Led5,LOW);
   break;
   case 2:
    if (debug == false) digitalWrite(Led1,HIGH);
    if (debug == false) digitalWrite(Led2,HIGH);
    digitalWrite(Led3,LOW);
    digitalWrite(Led4,LOW);
    digitalWrite(Led5,LOW);
   break;
   case 3:
    if (debug == false) digitalWrite(Led1,HIGH);
    if (debug == false) digitalWrite(Led2,HIGH);
    digitalWrite(Led3,HIGH);
    digitalWrite(Led4,LOW);
    digitalWrite(Led5,LOW);
   break;
    case 4:
    if (debug == false) digitalWrite(Led1,HIGH);
    if (debug == false) digitalWrite(Led2,HIGH);
    digitalWrite(Led3,HIGH);
    digitalWrite(Led4,HIGH);
    digitalWrite(Led5,LOW);
   break;
   case 5:
    if (debug == false) digitalWrite(Led1,HIGH);
    if (debug == false) digitalWrite(Led2,HIGH);
    digitalWrite(Led3,HIGH);
    digitalWrite(Led4,HIGH);
    digitalWrite(Led5,HIGH);
   break;
  
    
  }   
  
}


void FlipCard(int nr) {
 if (nr != CurrentCard) {  
   if (nr > CurrentCard) {
      Movement = leftover + ((nr - CurrentCard) * 20);
   }
   else
   {
     Movement = leftover + (((40-CurrentCard)+nr) * 20);
   }

   FlipFlap.step(Movement-10+cardoffset[nr]);
  leftover = 10-cardoffset[nr];
   if (debug) {Serial.print ("Card: "); Serial.print(nr);Serial.print (" Left over "); Serial.print(leftover); Serial.print (" Offset "); Serial.print(cardoffset[nr]);Serial.print (" Movement:"); Serial.println(Movement);}
 
   CurrentCard = nr;
 }
}

void beep(int duration) {
  digitalWrite(Speaker,HIGH);
  delay(duration);
  digitalWrite(Speaker,LOW);
}



